/**
 * 
 */
package com.app.web.jsf.component;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.webapp.UIComponentTag;


/**
 * Tag de jsp para poder usar el componente en una jsp.
 */
public class FormBeanTag extends UIComponentTag {

	private String bean = null;
	
	@Override
	public String getComponentType() {
		return FormBeanComponent.COMPONENT_TYPE;
	}

	@Override
	public String getRendererType() {
		return FormBeanComponent.DEFAULT_RENDERER_TYPE;
	}

	/* (non-Javadoc)
	 * @see javax.faces.webapp.UIComponentTag#setProperties(javax.faces.component.UIComponent)
	 */
	@Override
	protected void setProperties(UIComponent component) {
		super.setProperties(component);
		
		if (bean != null) {
			// Con isValueReference comprobamos si el valor del atributo puesto en la JSP se trata de EL (Expresion Languaje #{ } )
			if (isValueReference(bean)) { 
				final Application application = FacesContext.getCurrentInstance().getApplication();
				final FormBeanComponent formBeanComponent = (FormBeanComponent)component;
				formBeanComponent.setBeanBinding(application.createValueBinding(bean));
			}
		}
	}

	
	/* (non-Javadoc)
	 * @see javax.faces.webapp.UIComponentTag#release()
	 */
	@Override
	public void release() {
		super.release();
		bean = null;
	}

	/**
	 * @return the bean
	 */
	public String getBean() {
		return bean;
	}

	
	/**
	 * @param bean the bean to set
	 */
	public void setBean(String bean) {
		this.bean = bean;
	}

	
}
